package com.tridion.deployer.modules;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;
import java.io.Writer;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.tridion.configuration.Configuration;
import com.tridion.configuration.ConfigurationException;
import com.tridion.deployer.Module;
import com.tridion.storage.si4t.SearchIndexProcessor;
import com.tridion.transport.transportpackage.TransportPackage;
import com.tridion.util.FileUtils;
import com.tridion.util.TCMURI;

public class SearchModuleUtility {
	
	private Configuration config;
	private Logger log;
	public SearchModuleUtility(Module module)
	{
		config = module.getConfiguration();
		log = LoggerFactory.getLogger(module.getClass());
	}
	
	public SearchIndexProcessor initalizeSearchProcessor(TransportPackage currentPackage) {
		
		try {
			SearchIndexProcessor _processor = SearchIndexProcessor.getInstance();
			_processor.configureStorageInstance("", this.config.getParent().getParent().getParent());
			_processor.logSearchIndexInstances();
			return _processor;
		} catch (ConfigurationException e) {
			log.error("Cannot get configuration ", e);
		}
		catch(Exception e)
		{
			log.error("cd_deployer_conf is not configured properly ", e);
		}
		return null;
	}
	
	public static String readFileAsString(File sourceFile, String charsetName) throws IOException
	{
		String itemFile = null;

		if (charsetName != null) {
			itemFile = FileUtils.readEncodedFile(sourceFile, charsetName);
		} else {
			itemFile = FileUtils.readFile(sourceFile);
		}

		return itemFile;
	}

	public static Writer getWriter(File outputFile, String charsetName)
			throws FileNotFoundException, UnsupportedEncodingException
	{
		Writer w;
		if (charsetName != null) {
			w = new OutputStreamWriter(new FileOutputStream(outputFile), charsetName);
		} else {
			w = new OutputStreamWriter(new FileOutputStream(outputFile));
		}
		return w;
	}
}
